package java.beans.beancontext;

import java.util.Iterator;
import java.util.TooManyListenersException;

public interface BeanContextServices extends BeanContext, BeanContextServicesListener
{
    public abstract boolean addService(Class p0, BeanContextServiceProvider p1);
    
    public abstract void revokeService(Class p0, BeanContextServiceProvider p1, boolean p2);
    
    public abstract boolean hasService(Class p0);
    
    public abstract Object getService(BeanContextChild p0, Object p1, Class p2, Object p3, BeanContextServiceRevokedListener p4) throws TooManyListenersException;
    
    public abstract void releaseService(BeanContextChild p0, Object p1, Object p2);
    
    public abstract Iterator getCurrentServiceClasses();
    
    public abstract Iterator getCurrentServiceSelectors(Class p0);
    
    public abstract void addBeanContextServicesListener(BeanContextServicesListener p0);
    
    public abstract void removeBeanContextServicesListener(BeanContextServicesListener p0);
}
